<?php

include 'Lumine_ApplicationContext.php';

new Lumine_ApplicationContext();

if(!empty($_POST['materias'])){
	$pm = new PeriodoMateria();
	$pm->where('1=1')->delete(true);
	
	foreach($_POST['materias'] as $key => $value){
		list($serie,$periodo,$materia) = explode('-',$key);
		$pm->idSerie = $serie;
		$pm->idPeriodo = $periodo;
		$pm->idMateria = $materia;
		$pm->addMultiInsertItem();
	}
	
	$pm->multiInsert();
	header('Location: index.php?t='.time());
	exit;
}

$per = new Periodos();
$per->order('periodo')->find();
$periodos = $per->allToArray();

$ser = new Series();
$ser->order('serie')->find();
$series = $ser->allToArray();

$mat = new Materias();
$mat->order('materia')->find();
$materias = $mat->allToArray();

$pm = new PeriodoMateria();
$pm->alias('pm')
	->join(new Materias(),'inner','m','idMateria','idMateria')
	->selectAs()
	->select('m.materia')
	->order('m.materia')
	->find();
	
$materias_selecionadas = array();
while($pm->fetch()){
	$materias_selecionadas[$pm->idSerie][$pm->idPeriodo][] = $pm->toArray();
}

?>
<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js"> <!--<![endif]-->
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <title>Exemplo de gerenciamento de escola</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width">

        <link rel="stylesheet" href="assets/css/normalize.min.css">
        <link rel="stylesheet" href="assets/css/bootstrap.min.css">
        <link rel="stylesheet" href="assets/css/main.css">
        <link rel="stylesheet" href="assets/css/escola.css">

        <script src="assets/js/vendor/modernizr-2.6.2.min.js"></script>
    </head>
    <body>
        
		<form class="container escola" method="post" action="index.php">
			<div class="alert">
				<p>Arraste as materias para as séries e periodos desejados</p>
				
				<?php
				foreach($materias as $item){
					echo '<span data-idmateria="',$item['idMateria'],'" class="label label-info">', $item['materia'], '</span> ';
				}
				?>
			</div>
			
			<table class="table table-bordered table-striped">
				<tr>
					<th width="10%">Série</th>
					<?php
					$w = ceil(90 / count($periodos));
					foreach($periodos as $item){
						echo '<th width="',$w,'%">', $item['periodo'], '</th>';
					}
					?>
				</tr>
				<?php
				
				foreach($series as $item){
					echo '<tr><td>', $item['serie'], '</td>';
					
					foreach($periodos as $periodo){
						printf('<td class="drop" data-periodo="%d-%d">', $item['idSerie'], $periodo['idPeriodo']);
						
						if(!empty($materias_selecionadas[$item['idSerie']][$periodo['idPeriodo']])){
							foreach($materias_selecionadas[$item['idSerie']][$periodo['idPeriodo']] as $pmItem){
								printf('<span class="label label-warning" data-idmateria="%d">
										%s
										<input type="hidden" name="materias[%d-%d-%d]" value="%d">
									</span> ', $pmItem['idMateria'],$pmItem['materia'],$pmItem['idSerie'],$pmItem['idPeriodo'], $pmItem['idMateria'],$pmItem['idMateria']);
							}
						}
						
					}
					echo '</tr>';
				}
				
				?>
			</table>
			
			<div class="form-actions">
				<button class="btn btn-primary pull-left">Salvar Alterações</button>
			</div>
		</form>

		<!-- le scripts -->
		<script src="assets/js/vendor/jquery-1.10.1.min.js"></script>
        <script src="assets/js/vendor/bootstrap.min.js"></script>
        <script src="assets/js/vendor/jquery-ui.min.js"></script>
        <script src="assets/js/plugins.js"></script>
        <script src="assets/js/main.js"></script>

        <script>
            var _gaq=[['_setAccount','UA-2230147-1'],['_trackPageview']];
            (function(d,t){var g=d.createElement(t),s=d.getElementsByTagName(t)[0];
            g.src='//www.google-analytics.com/ga.js';
            s.parentNode.insertBefore(g,s)}(document,'script'));
			
			$(function(){
				$('.label').draggable({
					helper: 'clone'
				});
				
				$('.label-warning').on('click', function(){
					$(this).remove();
				});
				
				$('.drop').droppable({
					accept: '.label',
					
					drop: function(event,ui){
						var me = $(this);
						$(this).find('.label').each(function(){
							var me = $(this);
							if(me.data('idmateria') == ui.draggable.data('idmateria')){
								event.preventDefault();
							}
						});
						
						me.css('background-color','');
						
						if(!event.isDefaultPrevented()){
							var clone = ui.draggable.clone()
								.addClass('label-warning')
								.removeClass('label-info')
								.attr('title','Clique para remover')
								.append('<input type="hidden" name="materias['+me.data('periodo')+'-'+ui.draggable.data('idmateria')+']" value="'+ui.draggable.data('idmateria')+'">');
								
							clone.on('click', function(event){
								$(event.target).remove();
							});
							
							me.append( clone ).append(' ');
						}
					},
					
					over: function(){
						before = $(this).css('background-color');
						$(this).css('background-color','#FFCC00');
					},
					
					out: function(){
						$(this).css('background-color','');
					}
				});
			});
        </script>
    </body>
</html>
